<p align="center"> 
  <br/>  
  <a href="https://opensource.org/licenses/MIT"><img src="https://img.shields.io/badge/license-MIT-green.svg?color=3F51B5&style=for-the-badge&label=License&logoColor=000000&labelColor=ececec" alt="License: MIT"></a>
  <a href="https://discord.gg/D8JsnBEuKb">
    <img src="https://img.shields.io/discord/979116623879368755.svg?label=Discord&logo=Discord&style=for-the-badge&logoColor=000000&labelColor=ececec" atl="Discord"/>
  </a>
  <br/>  
  <br/>   
</p>

<p align="center">
<img src="design/immich-logo.svg" width="150" title="Login met aangepaste URL">
</p>
<h3 align="center">Immich - Hoogwaardige, self-hosted back-up oplossing voor foto's en video's</h3>
<br/>
<a href="https://immich.app">
<img src="design/immich-screenshots.png" title="Main Screenshot">
</a>
<br/>
<p align="center">
  <a href="README_zh_CN.md">中文</a>
  <a href="README_tr_TR.md">Türkçe</a>
  <a href="README_ca_ES.md">Català</a>
  <a href="README_es_ES.md">Español</a>
  <a href="README_fr_FR.md">Français</a>
  <a href="README_nl_NL.md">Nederlands</a>
  <a href="README_ja_JP.md">日本語</a>
</p>

## Disclaimer

- ⚠️ Het project wordt momenteel **zeer actief** ontwikkeld.
- ⚠️ Verwacht bugs en ingrijpende wijzigingen.
- ⚠️ **Gebruik de app niet als de enige manier om uw foto's en video's op te slaan.**
- ⚠️ Volg altijd het [3-2-1](https://www.backblaze.com/blog/the-3-2-1-backup-strategy/) backup plan voor je kostbare foto's en video's!

## Inhoud

- [Officiële documentatie](https://immich.app/docs)
- [Roadmap](https://github.com/orgs/immich-app/projects/1)
- [Demo](#demo)
- [Functies](#functies)
- [Introductie](https://immich.app/docs/overview/introduction)
- [Installatie](https://immich.app/docs/install/requirements)
- [Richtlijnen voor bijdragen](https://immich.app/docs/overview/support-the-project)
- [Steun het project](#steun-het-project)

## Documentatie

De belangrijkste documentatie, inclusief installatie handleidingen, zijn te vinden op https://immich.app/.

## Demo

De demo is te bekijken op https://demo.immich.app.

Voor de mobiele app kunt u gebruik maken van `https://demo.immich.app/api` voor de `Server Endpoint URL`

```bash title="Demo Credential"
De inloggegevens
email: demo@immich.app
wachtwoord: demo
```

```
Spec: Free-tier Oracle VM - Amsterdam - 2.4Ghz quad-core ARM64 CPU, 24GB RAM
```

# Functies

| Functies                                            | Mobiel | Web |
|-----------------------------------------------------|--------|-----|
| Upload en bekijk video's en foto's                  | Ja     | Ja  |
| Automatische back-up wanneer de app wordt geopend   | Ja     | NVT |
| Selectieve album(s) voor back-up                    | Ja     | NVT |
| Download foto's en video's naar een lokaal apparaat | Ja     | Ja  |
| Ondersteuning voor meerdere gebruikers              | Ja     | Ja  |
| Album en gedeelde albums                            | Ja     | Ja  |
| Versleepbare scroll balk                            | Ja     | Ja  |
| Ondersteuning voor het RAW formaat                  | Ja     | Ja  |
| Metagegevensweergave (EXIF, kaart)                  | Ja     | Ja  |
| Zoek op metagegevens, objecten, gezichten en CLIP   | Ja     | Ja  |
| Administratieve functies (gebruikersbeheer)         | Nee    | Ja  |
| Back-up op de achtergrond                           | Ja     | NVT |
| Virtueel scrollen                                   | Ja     | Ja  |
| OAuth-ondersteuning                                 | Ja     | Ja  |
| API-sleutels                                        | NVT    | Ja  |
| LivePhoto-back-up en weergave                       | iOS    | Ja  |
| Door de gebruiker gedefinieerde opslagstructuur     | Ja     | Ja  |
| Openbaar delen                                      | Nee    | Ja  |
| Archief en Favorieten                               | Ja     | Ja  |
| Wereldkaart                                         | Ja     | Ja  |
| Delen met partner                                   | Ja     | Ja  |
| Gezichtsherkenning en groepering                    | Ja     | Ja  |
| Herinneringen (x jaar geleden)                      | Ja     | Ja  |
| Offline-ondersteuning                               | Ja     | Nee |
| Alleen-lezen galerij                                | Ja     | Ja  |

# Steun het project

Ik ben trouw aan dit project en ik zal niet stoppen. Ik zal de documenten blijven bijwerken, nieuwe functies toevoegen en bugs oplossen. Maar ik kan het niet alleen. Ik heb dus jouw hulp nodig om mij extra motivatie te geven om door te gaan.

Als onze gastheren in de [selfhosted.show - In de aflevering 'The-organization-must-Neet-be-name is a Hostile Actor'](https://selfhosted.show/79?t=1418) zeiden, dit is een eNeerme onderneming van wat het team en ik doen. En ik zou dit graag fulltime willen doen, ik vraag jouw hulp om dat mogelijk te maken.

Als je denkt dat dit het juiste doel is en de app iets is dat je jezelf al heel lang ziet gebruiken, overweeg dan om het project te steunen met de onderstaande optie.

## Doneren

- [Maandelijkse donatie](https://github.com/sponsors/alextran1502) via GitHub Sponsors
- [Eenmalige donatie](https://github.com/sponsors/alextran1502?frequency=one-time&sponsor=alextran1502) via GitHub Sponsors
- [Librepay](https://liberapay.com/alex.tran1502/)
- [buymeacoffee](https://www.buymeacoffee.com/altran1502)
- Bitcoin: 1FvEp6P6NM8EZEkpGUFAN2LqJ1gxusNxZX
